/*
 * This program is a simple connect-to-local socket client.
 */

#include "pexec.h"
#include <stdio.h>

#define STDIN 0

int main( argc, argv )
int  argc;
char **argv;
{
PX_Ctx ctx;
int    fd;
PX_Handler close_fd, fd_to_set, err_fd, exit_on_close, fd_to_out;

PX_Ctx_init( &ctx );

fd = PX_FD_Create_local_conn( "/tmp/pexec", 1, (int *)0 );
if (fd < 0) {
    fprintf( stderr, "Could not open pexec port\n" );
    return 1;
    }

exit_on_close = PX_Handler_simple_create( PX_Hfcn_exit_on_close, (void *)0 );

/* Write to socket */
fd_to_set     = PX_Handler_simple_create( PX_Hfcn_fd_to_set, (void *)0 );
PX_FdAddToSet( fd_to_set, fd );

err_fd        = PX_Handler_simple_create( PX_Hfcn_error_fd, (void *)0 );

/* Setup an initial connection to stdin/out */
PX_FD_add( STDIN,  PX_READ, fd_to_set, err_fd, exit_on_close, 
	  (struct timeval *)0, &ctx );

/* If there is data on the socket, read it and write to OUR stdout */
fd_to_out    = PX_Handler_simple_create( PX_Hfcn_to_stdout, (void *)0 );
PX_FD_add( fd, PX_READ, fd_to_out, err_fd, (PX_Handler)0, 
	 (struct timeval *)0, &ctx );

/* gselect is basically an infinite loop */
if (PX_Gselect( &ctx, (void *)0 )) {
    perror( "Gselect failed" );
    return 1;
    }
return 0;
}
