/*
 * This code is a sample of how to start a subtree of processes on remote
 * systems.  This is a reliable start, with timeouts for the subtree root,
 * and "automatic" selection of a new subtree root.  
 *
 * In order for this to be reliable, a handshake is required with the 
 * created, remote process.  
 */

#include "pexec.h"

#ifndef MAX_HOST_NAME
#define MAX_HOST_NAME 128
#endif

typedef struct {
    char hostname[MAX_HOST_NAME];
    char *pgm;
    char **argv;
    } PX_RemotePgm;

typedef struct {
    int npgms;
    int curroot;
    PX_RemotePgm *rpgms;
    } PX_TreeStart;

/* 
 * This is the algorithm:
 *    Run rsh in a forked process with PX_Run_program
 *    The stdout handler has a timeout, and waits for the handshake
 *       ON_err( TIMEOUT ) closes the connection and kills the process,
 *       increments curroot, and starts over.
 *    If the handler is called, then it sends an OK (2nd half of handshake)
 *    and installs the input/output handlers for the process.
 *    This is done with each subtree.  The number of subtrees is controlled
 *    by tree_base; a value of 2 creates a binary tree; a value of 10000000
 *    (effectively) constructs a tree of depth one (no subtrees; all proceeses
 *    are leaves).
 *
 * An alternative form of this could try to connect to a running program first,
 * using the socket code.  The error handler on that would then try to 
 * run the program, and the error handler on that would give up on that node.
 */
int PX_StartTree( )
{
/* Construct the command line for the program and the local data for the
   handler */

/* Run the program */

/* Install the handlers */

return 0;
}

